' Copyright (c) 2007 Henric Jungheim <software@henric.info>
'
' Permission to use, copy, modify, and distribute this software for any
' purpose with or without fee is hereby granted, provided that the above
' copyright notice and this permission notice appear in all copies.
'
' THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
' WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
' MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
' ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
' WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
' ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
' OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.

Imports System
Imports System.Reflection

Namespace My

    ' The following events are availble for MyApplication:
    ' 
    ' Startup: Raised when the application starts, before the startup form is created.
    ' Shutdown: Raised after all application forms are closed.  This event is not raised if the application terminates abnormally.
    ' UnhandledException: Raised if the application encounters an unhandled exception.
    ' StartupNextInstance: Raised when launching a single-instance application and the application is already active. 
    ' NetworkAvailabilityChanged: Raised when the network connection is connected or disconnected.
    Partial Friend Class MyApplication

        Private arch As String

        Private Sub HandleStartup(ByVal sender As System.Object, ByVal e As ApplicationServices.StartupEventArgs) Handles Me.Startup
            Dim pa As String = Environment.GetEnvironmentVariable("PROCESSOR_ARCHITECTURE")

            If ("AMD64" = pa) Then
                arch = "x64"
            ElseIf ("x86" = pa) Then
                arch = "win32"
            End If
            AddHandler System.AppDomain.CurrentDomain.AssemblyResolve, AddressOf HandleResolve
        End Sub
        Private Function HandleResolve(ByVal sender As System.Object, ByVal args As System.ResolveEventArgs) As Assembly
            Dim path As String = System.IO.Path.Combine(AppDomain.CurrentDomain.BaseDirectory, arch)
            Dim an As AssemblyName = New AssemblyName(args.Name)
            path = System.IO.Path.Combine(path, an.Name + ".dll")
            Return Assembly.LoadFrom(path)
        End Function
    End Class

End Namespace

